//
//  JarnabyViewController.m
//  Jarnaby
//
//  Created by Shin-Young Jung on 10. 9. 22..
//  Copyright Brigham Young University Hawaii 2010. All rights reserved.
//

#import "JarnabyViewController.h"


@implementation JarnabyViewController

@synthesize textView;
@synthesize gestureEndPoint;
@synthesize gestureStartPoint;
@synthesize story;

-(IBAction) pressedInfo {
    UIAlertView *done = [[UIAlertView alloc] initWithTitle:@"About Us" message:@"This Hypertext storybook is owned by CS department in Brigham Young University-Hawaii. Programmers:\n Shin-Young Jung\nMatt Styles \n Advisor & Painter:\nDr. Geoff Draper"
                                                  delegate:self cancelButtonTitle:@"Close" otherButtonTitles:nil, nil];
    done.tag =1;
    [done show];
    [done release];

}

-(IBAction) goPrevious{
	//NSLog(@"prev");
	BOOL ok = NO;
	if(story.currentPath.defaultPath){
		if (story.index > 0){ok = YES;}
	} else {ok = YES;}
	if (ok){
		[UIView beginAnimations:@"View Flip" context:nil];
		[UIView setAnimationDuration:0.50];
		[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
		[UIView setAnimationTransition:UIViewAnimationTransitionCurlDown forView:self.view cache:YES];
		[self back];
		[UIView commitAnimations];
		
	}
}


-(IBAction) goNext {
    if(!titlethere){
        if(story.index < [[story.currentPath pathnum] count]-1){
            //NSLog(@"Next");
            [UIView beginAnimations:@"View Flip" context:nil];
            [UIView setAnimationDuration:0.50];
            [UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
            [UIView setAnimationTransition:UIViewAnimationTransitionCurlUp forView:self.view cache:YES];
            [self forward];
            [UIView commitAnimations];
        } else {
            UIAlertView *done = [[UIAlertView alloc] initWithTitle:@"Congratulations!" message:@"You are done with your reading. You can go back to the first page or go to Map."
                                                      delegate:self cancelButtonTitle:@"Map" otherButtonTitles:@"First page", nil];
             done.tag =0;
            [done show];
            [done release];
        }
    }
}
-(void)mapAux {
	
	[mapView setScrollEnabled:YES];
    for(int i=0; i < [story.paths count]; i++){
		if([story.currentPath isEqual:[story.paths objectAtIndex:i]]){
			story.currentPathnum = i;
		}
	}
	int count=0; int point=0;
	for(int i=0; i < [[story.currentPath pages] count]; i++){
		if([[[story.currentPath pages] objectAtIndex:i] visited] == YES){
			count=i+1;
		}
		if(story.currentPageID == [[[story.currentPath pages] objectAtIndex:i] ID]){
			point = i;
		}
	}
	int length = (count+2)*160;
	int width = 750;
	[mapView setContentSize:CGSizeMake(width, length)];
	[mapView setBackgroundColor:[UIColor whiteColor]];
    
	//this is for setting focus
    [mapView setContentOffset:CGPointMake(230, point*140)];
    
	mapViewinSide.frame = CGRectMake(0, 0, width, length);
    
	[mapViewinSide setR:338 T:48+(point*140) Th:452 F:172+(point*140)];
	for (int i=0; i < [story.paths count]; i++){
		for(int j=0; j < [[[story.paths objectAtIndex:i] pages] count]; j++){
			if([story.currentPath isEqual:[story.paths objectAtIndex:i]]){
				Page *p = [[[story.paths objectAtIndex:i] pages] objectAtIndex:j];
				CGRect buttonRect;
				if(count >= j){
					buttonRect = CGRectMake(0, 0+(140*j), 110, 120);
					UIButton *button = [[UIButton alloc] initWithFrame:buttonRect];
					UIImage *image;
					if(p.visited == YES){
						image = [UIImage imageNamed:[p getImage]];
					} else {
						image = [UIImage imageNamed:@"unvisited.png"];
					}
					[button setBackgroundImage:image forState:UIControlStateNormal];
					NSString * t = [[NSString alloc] initWithString:[NSString stringWithFormat:@"%d,%d",i,p.ID]];
					[button setTag:t];
					
					[button addTarget:self action:@selector(mapButtonClicked:) forControlEvents:UIControlEventTouchUpInside];
					//[[views objectAtIndex:i] setFrame:CGRectMake(340, 47, width, length)];
					[[views objectAtIndex:i] setBackgroundColor:[UIColor whiteColor]];
					
					[[views objectAtIndex:i] addSubview:button];
					
					
					if([[[story.currentPath pages] objectAtIndex:j] link] && ([[story.Links objectForKey:[NSString stringWithFormat:@"%d",story.currentPageID]] pathref] != story.currentPathnum)){
						
						int a = [[story.Links objectForKey:[NSString stringWithFormat:@"%d", p.ID]] pathref];
						int b = [[story.Links objectForKey:[NSString stringWithFormat:@"%d", p.ID]] pageref];
						Page *lp;
						
						[mapViewinSide setLink:340 T:120+(140*j) Th:180 F:220+(140*j) li: a];
						for(int k=0; k < [[[story.paths objectAtIndex:a] pages] count]; k++){
							if ([[[[story.paths objectAtIndex:a] pages] objectAtIndex:k] ID] == b){
								lp = [[[story.paths objectAtIndex:a] pages] objectAtIndex:k]; 
							}
						}
						UIImage *image;
						NSString *t;
						if(a%2 == 0){
							buttonRect = CGRectMake(125, 220+(140*j), 110, 120);
						} else {
							buttonRect = CGRectMake(575, 220+(140*j), 110, 120);
						}
						[buttons addObject:[[UIButton alloc] initWithFrame:buttonRect]];
						if([lp visited]){
							image = [UIImage imageNamed:[lp getImage]];
						} else {
							image = [UIImage imageNamed:@"unvisited.png"];
						}
						t = [[NSString alloc] initWithString:[NSString stringWithFormat:@"%d,%d",a,b]];
						[[buttons objectAtIndex:[buttons count]-1] setBackgroundImage:image forState:UIControlStateNormal];
						[[buttons objectAtIndex:[buttons count]-1] setTag:t];
						[[buttons objectAtIndex:[buttons count]-1] addTarget:self action:@selector(mapButtonClicked:) forControlEvents:UIControlEventTouchUpInside];
						//[mapView addSubview:[views objectAtIndex:a]];
						[mapViewinSide addSubview:[buttons objectAtIndex:[buttons count]-1]];
					}
					[mapViewinSide setNeedsDisplay];
					//[mapView addSubview:[views objectAtIndex:i]];
				}
			}
			
		}
	}
	
}

-(IBAction) pressedMap {
    
	int count=0;
	//	for(int k=0; k < [story.paths count]; k++){
	//		CGRect buttonRect;
	//		buttonRect = CGRectMake(10, 10+(100*k), 200, 100);
	//		UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	//		[button setFrame:buttonRect];//[[UIButton alloc] initWithFrame:buttonRect];
	//		//button.backgroundColor = [UIColor blueColor];
	//		//[button setTitle:[[story.paths objectAtIndex:k] pathName] forState:UIControlStateNormal];
	//		//[button setTitle:@"this" forState:UIControlStateNormal];
	//		NSString * t = [[NSString alloc] initWithString:[NSString stringWithFormat:@"%d,%d",k,k]];
	//		[button setTag:t];
	//		
	//		[button addTarget:self action:@selector(mapButtonClicked:) forControlEvents:UIControlEventTouchUpInside];
	//		//[[views objectAtIndex:i] setFrame:CGRectMake(340, 47, width, length)];
	//		[mapViewinSide addSubview:button];
	//		
	//	}
	
	for(int i=0; i < [[story.currentPath pages] count]; i++){
		if([[[story.currentPath pages] objectAtIndex:i] visited] == YES){
			count=i+1;
		}
	}
	int length = (count+1)*160;
	int width = 110;
	views = [[NSMutableArray alloc] init];
	for(int g=0; g < [story.paths count]; g++){
		if([story.currentPath isEqual:[story.paths objectAtIndex:g]]){
			[views addObject:[[UIView alloc] initWithFrame:CGRectMake(340, 50, width, length)]];
		} else {
			if(g % 2 == 0){
				[views addObject:[[UIView alloc] initWithFrame:CGRectMake(120, 150, width, length)]];
				[[views objectAtIndex:g] setAlpha:0];
			} else {
				[views addObject:[[UIView alloc] initWithFrame:CGRectMake(575, 150, width, length)]];
				[[views objectAtIndex:g] setAlpha:0];
			}
		}
		[mapView addSubview:[views objectAtIndex:g]];
	}
	
	[self mapAux];
	
	CGRect secondFrame = mapView.frame;
	secondFrame.origin.y = 1100;
	mapView.frame = secondFrame;
	

	
	[UIView beginAnimations:@"advancedAnimations" context:nil];
	[UIView setAnimationDuration:1.00];
	
	secondFrame.origin.y = 0;
	
	mapView.frame = secondFrame;
	[mapViewinSide setAlpha:1];
	[self.view addSubview:mapView];
	[UIView commitAnimations];
	
}


-(IBAction) mapButtonClicked: (id)sender {
	NSArray *lines = [[sender tag] componentsSeparatedByString:@","];
	//NSLog([sender tag]);
	for(int i=0; i < [story.paths count]; i++){
		if([story.currentPath isEqual:[story.paths objectAtIndex:i]]){
			story.currentPathnum = i;
		}
	}
	if([story.currentPath isEqual:[story.paths objectAtIndex:[[lines objectAtIndex:0] integerValue]]]){
		
		CGRect secondFrame = mapView.frame;
		secondFrame.origin.y = 0;
		mapView.frame = secondFrame;
		[UIView beginAnimations:@"advancedAnimations" context:nil];
		[UIView setAnimationDuration:1.0];
		
		secondFrame.origin.y = 1100;
		
		mapView.frame = secondFrame;
		[UIView commitAnimations];
		story.currentPageID = [[lines objectAtIndex:1] integerValue];
		story.currentPath = [[story paths] objectAtIndex:[[lines objectAtIndex:0] integerValue]];
		for(int i =0; i < [[story.currentPath pages] count]; i++){
			if([[[story.currentPath pages] objectAtIndex:i] ID] == [[lines objectAtIndex:1] integerValue]){
				story.index = i; 
			}
		}
		story.currentPage = [story getPage:story.currentPageID];
		NSMutableArray *texts = [[NSMutableArray alloc] initWithArray:story.currentPage.texts];
		
		if (story.currentPage.link && ([[story.Links objectForKey:[NSString stringWithFormat:@"%d",story.currentPageID]] pathref] != story.currentPathnum)) {
                //[link_button setFrame:CGRectMake(0, 0, 0, 0)];
                //float xP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] xPos];
                //float yP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] yPos];
                //float widthP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] widthPos];
                //float heightP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] heightPos];
                //[link_button setFrame:CGRectMake(xP*pics.bounds.size.width, yP*pics.bounds.size.height, widthP*pics.bounds.size.width, heightP*pics.bounds.size.height)];
			link_button.alpha =1;
			link_button.enabled =YES;
			for(int i=0; i < [texts count]; i++){
				NSString *st1 = [texts objectAtIndex:i];
				NSRange match;
				match = [st1 rangeOfString:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]];
				if(match.location != NSNotFound){
					NSString *st2 = [NSString stringWithFormat:@"<a href = %@ >%@</a>", [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name], [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]];
					[[texts objectAtIndex:i] replaceCharactersInRange:[[texts objectAtIndex:i] rangeOfString:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]] withString:st2];
				}
			}
		} else {
			link_button.alpha =0;
			link_button.enabled =NO;
		}
		
		
		NSString *image = [story.currentPage getImage];
		[pics setImage:[UIImage imageNamed:image]];
		[story.currentPage setVisited:TRUE];
		
		//removing all the stack right before the current imageview
		
		// text loading
		[self textLoading:texts];
		for(int i=0; i < [buttons count]; i++){
			[[buttons objectAtIndex:i] removeFromSuperview];
		}
		for(int i=0; i < [views count]; i++){
			[[views objectAtIndex:i] removeFromSuperview];
		}
		[mapViewinSide setAlpha:0];
	} else {
		[UIView beginAnimations:@"advancedAnimations" context:nil];
		[UIView setAnimationDuration:0.5];
		int viewindex;
		//NSLog(@"%@",[sender tag]);
		for (int i=0; i < [story.paths count]; i++){
			if ([story.currentPath isEqual:[story.paths objectAtIndex:i]]){
				viewindex = i;
			}
		}
		int count=0; int point=0;
		for(int i=0; i < [[story.currentPath pages] count]; i++){
			if([[[story.currentPath pages] objectAtIndex:i] visited] == YES){
				count=i;
			}
		}
		int length = (count+2)*160;
		if(viewindex % 2 == 0){
			[[views objectAtIndex:viewindex] setFrame:CGRectMake(120, 50, 110, 350)];
		}else {
			[[views objectAtIndex:viewindex] setFrame:CGRectMake(520, 50, 110, 350)];
		}
		[[views objectAtIndex:viewindex] setAlpha:0];
		[[views objectAtIndex:[[lines objectAtIndex:0] integerValue]] setAlpha:1];
		[[views objectAtIndex:[[lines objectAtIndex:0] integerValue]] setFrame:CGRectMake(340, 50, 110, length)];
		story.currentPath = [story.paths objectAtIndex:[[lines objectAtIndex:0] integerValue]];
		for(int a=0; a < [[story.currentPath pages] count]; a++){
			if ([[lines objectAtIndex:1] integerValue] == [[[story.currentPath pages] objectAtIndex:a] ID]){
				[[[story.currentPath pages] objectAtIndex:a] setVisited:YES];
				story.currentPage =[[story.currentPath pages] objectAtIndex:a];
				story.currentPageID = story.currentPage.ID; 
			}
		}
		for(int i=0; i < [buttons count]; i++){
			[[buttons objectAtIndex:i] removeFromSuperview];
		}
		[self mapAux];
		[UIView commitAnimations];
		
	}
	
}

//press link in the text
- (BOOL)webView:(UIWebView*)webView shouldStartLoadWithRequest:(NSURLRequest*)request navigationType:(UIWebViewNavigationType)navigationType {
	if(navigationType == UIWebViewNavigationTypeLinkClicked) {[self pressedLink]; return YES;}
	return YES;	
}


-(IBAction) pressedLink {
	[UIView beginAnimations:@"View Flip" context:nil];
	[UIView setAnimationDuration:1.25];
	[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
	//int pathnumber=0;
	for(int i=0; i < [story.paths count]; i++){
		if([story.currentPath isEqual:[story.paths objectAtIndex:i]]){
			story.currentPathnum = i;
		}
	}
	story.currentPath = [story.paths objectAtIndex:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] pathref]];
	for(int i =0; i < [[story.currentPath pages] count]; i++){
		if([[[story.currentPath pages] objectAtIndex:i] ID] == [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] pageref]){
			story.currentPage = [[story.currentPath pages] objectAtIndex:i];
			story.index = i;
		}
	}
	
	link_button.alpha =0;
	link_button.enabled =NO;
	
	story.currentPage = [story getPage:story.currentPage.ID];
	[story.currentPage setVisited:YES];
	story.currentPageID = story.currentPage.ID;
	NSMutableArray *texts = [[NSMutableArray alloc] initWithArray:story.currentPage.texts];
	
	if (story.currentPage.link && ([[story.Links objectForKey:[NSString stringWithFormat:@"%d",story.currentPageID]] pathref] != story.currentPathnum)) {
        //[link_button setFrame:CGRectMake(0, 0, 0, 0)];
		//float xP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] xPos];
		//float yP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] yPos];
		//float widthP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] widthPos];
		//float heightP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] heightPos];
		//[link_button setFrame:CGRectMake(xP*pics.bounds.size.width, yP*pics.bounds.size.height, widthP*pics.bounds.size.width, heightP*pics.bounds.size.height)];
		link_button.alpha =1;
		link_button.enabled =YES;
		for(int i=0; i < [texts count]; i++){
			NSString *st1 = [texts objectAtIndex:i];
			NSRange match;
			match = [st1 rangeOfString:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]];
			if(match.location != NSNotFound){
				NSString *st2 = [NSString stringWithFormat:@"<a href = %@ >%@</a>", [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name], [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]];
				[[texts objectAtIndex:i] replaceCharactersInRange:[[texts objectAtIndex:i] rangeOfString:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]] withString:st2];
			}
		}
	} else {
		link_button.alpha =0;
		link_button.enabled =NO;
	}
	
	NSString *image = [story.currentPage getImage];
	[pics setImage:[UIImage imageNamed:image]];
	
	
	// text loading
	[self textLoading:texts];
	
	[UIView setAnimationTransition:UIViewAnimationTransitionFlipFromLeft forView:self.view cache:YES];
	[UIView commitAnimations];
	
}
/*
 // The designated initializer. Override to perform setup that is required before the view is loaded.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
 
 }
 return self;
 }
 */

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView {
 
 }
 */



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	CGRect opening = titlePageView.frame;
	opening.origin.y = 0;
	titlePageView.frame = opening;
	[self.view addSubview:titlePageView];
    titlethere = YES;
	//wait for 3 sec
	//[NSTimer scheduledTimerWithTimeInterval:3.0 target:self selector:@selector(fireTimer:) userInfo:nil repeats:YES];
	
	buttons = [[NSMutableArray alloc] init];
	
	//set default path with current page and current path
	story = [[Story alloc] init];
	for(int a=0; a < [[story paths] count]; a++) {
		if([[[story paths] objectAtIndex:a] defaultPath]){
			story.currentPath = [[story paths] objectAtIndex:a];
			int c = [ [[[[story paths] objectAtIndex:a] pathnum] objectAtIndex:0] integerValue];
			story.currentPage = [story getPage:c];
			break;
		}
	}
	
	[story.currentPage setVisited:YES];
	
	link_button.alpha =0;
	link_button.enabled =NO;
	prev.alpha = 0;
	[pics setImage:[UIImage imageNamed:story.currentPage.imageFile]];
	// text loading
	NSString *head = @"<html><head><title></title></head><body style=\"background-color: transparent;\"><font size=\"4\">";
	NSMutableString * body = [[NSMutableString alloc] init];
	for(int i=0; i < [story.currentPage.texts count]; i++){
		[body appendFormat:[story.currentPage.texts objectAtIndex:i]];
	}
	NSString *tail = @"</font></body></html>";
	NSString *htmlString = [[NSString alloc] initWithString:[NSString stringWithFormat:@"%@%@%@",head,body,tail]];
	textView.opaque = NO;
	textView.backgroundColor = [UIColor clearColor];
	[self.textView loadHTMLString:htmlString baseURL:nil];
	[htmlString release];
	[head release];
	[body release];
	[tail release];
	
	[super viewDidLoad];
}

-(IBAction) startStory{
    titlethere = NO;
	CGRect opening = titlePage.frame;
	[UIView beginAnimations:@"advancedAnimations" context:nil];
	[UIView setAnimationDuration:1.00];
	opening.origin.x = 0;
	opening.origin.y = 1100;
	titlePageView.frame = opening;
	[UIView commitAnimations];
}
-(IBAction) instruction{
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"How to" message:@"Welcome to the Jarnaby eReader! In a Jarnaby story, there are many possible paths through the story. While you are welcome to follow the default path from start to finish, the full story can only be experienced by exploring multiple paths. To turn the pages, use the 'prev' and 'next' buttons found in the bottom-left and bottom-right corners of the screen. You may also use touch gestures to turn the page by sliding your finger to the left to go back, and sliding to the right to go forward. Some pages contain hyperlinked button at the top-right coner that take you to another path in the story. For an overhead view of the story, use the 'map' button found at the top of the screen. While in this view you can view the path of the story up to the point that you have read so far. Pages you have yet to explore will show as a \"\?\". The page at the top of the map view will be the first page of that particular path. To return to the normal view, press the 'map' button to display the currently selected page, or select a different page from the path."
												   delegate:self cancelButtonTitle:@"Done" otherButtonTitles:nil, nil];
	alert.tag = 1;
    [alert show];
	//alert.frame = CGRectMake( 30, 30, 600, 700 );
	[alert release];
}


- (void) fireTimer:(NSTimer*)theTimer {
	CGRect opening = titlePageView.frame;
	
	[UIView beginAnimations:@"advancedAnimations" context:nil];
	[UIView setAnimationDuration:1.00];
	opening.origin.x = 0;
	opening.origin.y = 470;
	titlePageView.frame = opening;
	NSLog(@"timer timer timer is working");
	[UIView commitAnimations];
	//kill the timer
	[theTimer invalidate];
	theTimer = nil;
	
}


-(void)back {	
	//int pathnumber=0;
	for(int i=0; i < [story.paths count]; i++){
		if([story.currentPath isEqual:[story.paths objectAtIndex:i]]){
			story.currentPathnum = i;
		}
	}
	if(story.currentPath.defaultPath && story.index == 1){
		prev.alpha = 0;
	} else{
		prev.alpha = 1;
	}
	if(story.index > 0){
		story.index--;
		story.currentPageID = [[ [story.currentPath pathnum] objectAtIndex:story.index] integerValue];
		story.currentPage = [story getPage:story.currentPageID];
		
		NSMutableArray *texts = [[NSMutableArray alloc] initWithArray:story.currentPage.texts];
		
		if (story.currentPage.link && ([[story.Links objectForKey:[NSString stringWithFormat:@"%d",story.currentPageID]] pathref] != story.currentPathnum)) {
              //[link_button setFrame:CGRectMake(0, 0, 0, 0)];
			//float xP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] xPos];
			//float yP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] yPos];
			//float widthP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] widthPos];
			//float heightP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] heightPos];
			//[link_button setFrame:CGRectMake(xP*pics.bounds.size.width, yP*pics.bounds.size.height, widthP*pics.bounds.size.width, heightP*pics.bounds.size.height)];
			link_button.alpha =1;
			link_button.enabled =YES;
			for(int i=0; i < [texts count]; i++){
				NSString *st1 = [texts objectAtIndex:i];
				NSRange match;
				match = [st1 rangeOfString:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]];
				if(match.location != NSNotFound){
					NSString *st2 = [NSString stringWithFormat:@"<a href = %@ >%@</a>", [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name], [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]];
					[[texts objectAtIndex:i] replaceCharactersInRange:[[texts objectAtIndex:i] rangeOfString:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]] withString:st2];
				}
			}
			
		} else {
			link_button.alpha =0;
			link_button.enabled =NO;
		}
		[story.currentPage setVisited:YES];
		NSString *image = [story.currentPage getImage];
		[pics setImage:[UIImage imageNamed:image]];
		
		
		// text loading
		[self textLoading:texts];
		
	} else {
		NSEnumerator *enumerator;
		id key;
		int pageID;
		enumerator = [story.Links keyEnumerator];
		while ((key = [enumerator nextObject])){
			if (story.currentPage.ID == [[story.Links objectForKey:key] pageref]){
				pageID = [key integerValue];
				break;
			}
		}
		for(int i=0; i < [story.paths count]; i++){
			for(int j=0; j < [[[story.paths objectAtIndex:i] pages] count]; j ++){
				if(pageID == [[[[story.paths objectAtIndex:i] pages] objectAtIndex:j] ID]){
					story.currentPath = [story.paths objectAtIndex:i];
					story.currentPage = [[[story.paths objectAtIndex:i] pages] objectAtIndex:j];
					story.index = j;
					i = [story.paths count];
					break;
				}
			}
		}
		NSMutableArray *texts = [[NSMutableArray alloc] initWithArray:story.currentPage.texts];
		if (story.currentPage.link && ([[story.Links objectForKey:[NSString stringWithFormat:@"%d",story.currentPageID]] pathref] != story.currentPathnum)) {
              //[link_button setFrame:CGRectMake(0, 0, 0, 0)];
			//float xP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] xPos];
			//float yP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] yPos];
			//float widthP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] widthPos];
			//float heightP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] heightPos];
			//[link_button setFrame:CGRectMake(xP*pics.bounds.size.width, yP*pics.bounds.size.height, widthP*pics.bounds.size.width, heightP*pics.bounds.size.height)];
			link_button.alpha =1;
			link_button.enabled =YES;

			//for(int i=0; i < [texts count]; i++){
			//				NSString *st1 = [texts objectAtIndex:i];
			//				NSRange match;
			//				match = [st1 rangeOfString:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] text]];
			//				if(match.location != NSNotFound){
			//					NSString *st2 = [NSString stringWithFormat:@"<a href = %@ >%@</a>", [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] text], [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] text]];
			//					[[texts objectAtIndex:i] replaceCharactersInRange:[[texts objectAtIndex:i] rangeOfString:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] text]] withString:st2];
			//				}
			//			}
		} else {
			link_button.alpha =0;
			link_button.enabled =NO;
		}
		[story.currentPage setVisited:YES];
		NSString *image = [story.currentPage getImage];
		[pics setImage:[UIImage imageNamed:image]];
		
		// text loading
		[self textLoading:texts];
	} 
	
}

-(void)forward {
	//int pathnumber=0;
	prev.alpha = 1;
	for(int i=0; i < [story.paths count]; i++){
		if([story.currentPath isEqual:[story.paths objectAtIndex:i]]){
			story.currentPathnum = i;
		}
	}
	if(story.index < [[story.currentPath pathnum] count]-1){
		story.index++;
		story.currentPageID = [[ [story.currentPath pathnum] objectAtIndex:story.index] integerValue];
		story.currentPage = [story getPage:story.currentPageID];
		
		
		NSMutableArray *texts = [[NSMutableArray alloc] initWithArray:story.currentPage.texts];
		
		if (story.currentPage.link && ([[story.Links objectForKey:[NSString stringWithFormat:@"%d",story.currentPageID]] pathref] != story.currentPathnum)) {
            //[link_button setFrame:CGRectMake(0, 0, 0, 0)];
			//float xP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] xPos];
			//float yP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] yPos];
			//float widthP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] widthPos];
			//float heightP = [[story.rect objectForKey:[NSString stringWithFormat:@"%d", story.currentPage.ID]] heightPos];
			//[link_button setFrame:CGRectMake(xP*pics.bounds.size.width, yP*pics.bounds.size.height, widthP*pics.bounds.size.width, heightP*pics.bounds.size.height)];
			link_button.alpha =1;
			link_button.enabled =YES;
			for(int i=0; i < [texts count]; i++){
				NSString *st1 = [texts objectAtIndex:i];
				NSRange match;
				match = [st1 rangeOfString:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]];
				if(match.location != NSNotFound){
					NSString *st2 = [NSString stringWithFormat:@"<a href = %@ >%@</a>", [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name], [[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]];
					[[texts objectAtIndex:i] replaceCharactersInRange:[[texts objectAtIndex:i] rangeOfString:[[story.Links objectForKey:[NSString stringWithFormat:@"%d", story.currentPageID]] name]] withString:st2];
				}
			}
		} else {
			link_button.alpha =0;
			link_button.enabled =NO;
		}
		
		
		//[stack addObject:story.currentPage];
		
		NSString *image = [story.currentPage getImage];
		[pics setImage:[UIImage imageNamed:image]];
		[story.currentPage setVisited:YES];
		
		// text loading
		[self textLoading:texts];
	} 
	
}

-(void)textLoading:(NSMutableString *)texts {
	NSString *head = @"<html><head><title></title></head><body style=\"background-color: transparent;\"><font size=\"4\">";
	NSMutableString * body = [[NSMutableString alloc] init];
	for(int i=0; i < [texts count]; i++){
		[body appendFormat:[texts objectAtIndex:i]];
	}
	NSString *tail = @"</font></body></html>";
	NSString *htmlString = [[NSString alloc] initWithString:[NSString stringWithFormat:@"%@%@%@",head,body,tail]];
	textView.opaque = NO;
	textView.backgroundColor = [UIColor clearColor];
	[self.textView loadHTMLString:htmlString baseURL:nil];
	[htmlString release];
	[head release];
	[body release];
	[tail release];
	
}

// not allowing auto rotation for landscape
-(BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)orientation
{
    return (orientation != UIDeviceOrientationLandscapeLeft) &&
    (orientation != UIDeviceOrientationLandscapeRight);
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
	[super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[super dealloc];
}

#pragma mark - Flip animation



- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
	UITouch *touch = [touches anyObject];
	gestureStartPoint = [touch locationInView:self.view];
}

-(void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
	
	
	UITouch *touch = [touches anyObject];
	
	if(!titlethere){
	gestureEndPoint = [touch locationInView:self.view];
	if (gestureEndPoint.x - gestureStartPoint.x < 0){
		if(story.index < [[story.currentPath pathnum] count]-1){
			[UIView beginAnimations:@"View Flip" context:nil];
			[UIView setAnimationDuration:0.50];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
			[UIView setAnimationTransition:UIViewAnimationTransitionCurlUp forView:self.view cache:YES];
			[self forward];
			[UIView commitAnimations];
		} else {
            UIAlertView *done = [[UIAlertView alloc] initWithTitle:@"Congratulations!" message:@"You are done with your reading. You can go back to the first page or go to Map."
                                                          delegate:self cancelButtonTitle:@"Map" otherButtonTitles:@"First page", nil];
            done.tag =0;
            [done show];
            [done release];

        }
	} else if (gestureEndPoint.x - gestureStartPoint.x > 0){
		BOOL ok = NO;
		if(story.currentPath.defaultPath){
			if (story.index > 0){ok = YES;}
		} else {ok = YES;}
		
		if(ok){
			[UIView beginAnimations:@"View Flip" context:nil];
			[UIView setAnimationDuration:0.50];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
			[UIView setAnimationTransition:UIViewAnimationTransitionCurlDown forView:self.view cache:YES];
			[self back];
			[UIView commitAnimations];
		}
	}
	}
}

- (void)alertView:(UIAlertView *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
	// the user clicked one of the OK/Cancel buttons
    if(actionSheet.tag == 1){
        if(buttonIndex == 0){
            
        }
    }else{
        if (buttonIndex == 0)
        {
            [self pressedMap];
        }
        else
        {
            [self viewDidLoad];
        }
    }
}


@end
